# 2048 Game

- [The Rules](#the-rules)
- [The Functions](#the-functions-in-depth)
- [Images](#images)
- [How To Play](#how-to-play) 
- [Show randomness](#randomness-proof)



## In this Code I am going to be recreating the classic [2048](https://play2048.co/) in a linux command line.



# The Rules

* If 2 of the same numbers touch they will combine and add up to the value of both
  added together (e.g. if a 2 block touches another 2 block they will combine and become one 4 block).

* You can use w/a/s/d or W/A/S/D to control the game.

* If there is no empty cells left with no valid moves then the game will end.

* If you get one of the cells to 2048 you win.

## The functions in depth

### Initilise Function

First we set a seed for our random number generator using the system time as the seed.
Then we set the `gameOver` and the` moved `variables to false to get it ready.
Then we use for loops in order to create the board.
Then run the generateRandomTile function to create the first tiles in the game.

### Run Function

This just makes sure that if the game isnt over it prints the board out and starts looking for user input and if the game is over it prints an end message.

### Generate Random Tile Function

We first check if there are any empty cells on the board.

If there are no empty cells then the game will end.

A random number generator will get a random number and devide it by the empty cells variable with the modulo operator then use the remainder of that operation + 1 and put this number in the randomIndex variable.
We then use for loops to look through the grid while empty cells increments by one after every cell that isnt occupied and when the empty cells variable becomes the same as the random index it will pass to another if statement.

The final if statement will get a random number and divide it by 2 and the results should be limited to 0 or 1 we then add 1 to the result so that the only results should be 1 or 2 then we multiply that by 2 so that the only result that we should get is 2 or 4 this is then set to the index on the board and the function is exited.

### Print Board Function

First we use linux system commands to clear the previous grid and then loop through the board using the setw code to make it format a bit nicer.

### User Input Function

I initilise a variable to hold the user input and then output to ask for movement key and this key is stored in the input variable.

I then use a switch statement to match what key was pressed and to run a function to move the board in the respected way that was inputted.

### Move Functions

Because they are all similar i will just combine them all together like how only one has commments on it in the code. I will just explain `Moveleft`. For the movement functions i first created a for loop that loops through all of the rows on the grid then there is another for loop. While it loops through it checks if the current tile is empty and if it is it will find the first number tile on the right making it position `[i] [k]` and move it left to the current position `[i] [j]` then sets the current postion `[i] [j]` to empty or 0. 
We then use an else statement to try and merge tiles if the current tile isnt empty is done by checking if the tile next to it is empty     `board[i][k] != 0` if `[i][k]` isnt 0 then i check if the current position `[i][j]` matches with the target position `[i][k]` if it does then i merge them by multiplying the leftmost one `[i][k]` by itsself and setting the other one to 0 and setting the movement bool to true.

The only differences between the others is that `moveright` checks for merges on the right. `moveup` and `movedown` loops through the grid column then rows whereas move right and left loops though row then column.

### How To Run

    Compile using   "clang++ main.cpp 2048.cpp -o 2048"
    Then run using ./2048

#### How To Play
  Use Keys W,A,S,D to select your move and press enter to submit your move.
  then follow [The Rules](#the-rules)

# Images

![The Starting Grid Of My 2048 with the randomised starting numbers](https://gitlab.uwe.ac.uk/h45-taylor/assignment-2048/-/raw/master/Screenshots/Starting%20grid.png?ref_type=heads "The Starting Grid Of My 2048")

# Randomness Proof

I have created a program [rnd.cpp](https://gitlab.uwe.ac.uk/h45-taylor/assignment-2048/-/blob/master/rnd.cpp?ref_type=heads) that uses the same mathematics as my 2048 game and outputs and totals all of the results to get an idea of how random for how favoured in one direction it is.